<?php

declare(strict_types=1);

namespace Dedi\SyliusContactPlugin\Fixture;

use Doctrine\Persistence\ObjectManager;
use Sylius\Bundle\CoreBundle\Fixture\Factory\ExampleFactoryInterface;
use Sylius\Bundle\FixturesBundle\Fixture\FixtureInterface;
use Symfony\Component\Config\Definition\Builder\ArrayNodeDefinition;
use Symfony\Component\Config\Definition\Builder\TreeBuilder;

class ContactFormMessageFixture implements FixtureInterface
{
    public function __construct(
        private readonly ObjectManager $objectManager,
        private readonly ExampleFactoryInterface $subjectFactory,
    ) {
    }

    public function getConfigTreeBuilder(): TreeBuilder
    {
        $treeBuilder = new TreeBuilder($this->getName());

        /** @var ArrayNodeDefinition $optionsNode */
        $optionsNode = $treeBuilder->getRootNode();

        $optionsNode
            ->children()
            ->integerNode('subject_id')->end()
            ->scalarNode('name')->end()
            ->scalarNode('email')->end()
            ->scalarNode('phone')->end()
            ->scalarNode('message')->end()
            ->end();

        return $treeBuilder;
    }

    public function load(array $options): void
    {
        $subject = $this->subjectFactory->create($options);
        $this->objectManager->persist($subject);
        $this->objectManager->flush();
    }

    public function getName(): string
    {
        return 'contact_message';
    }
}
