<?php

declare(strict_types=1);

namespace Dedi\SyliusContactPlugin\Fixture\Factory;

use Dedi\SyliusContactPlugin\Entity\ContactFormMessageInterface;
use Dedi\SyliusContactPlugin\Entity\ContactFormSubjectInterface;
use Dedi\SyliusContactPlugin\Factory\ContactFormMessageFactoryInterface;
use Dedi\SyliusContactPlugin\Repository\ContactFormSubjectRepositoryInterface;
use Sylius\Bundle\CoreBundle\Fixture\Factory\ExampleFactoryInterface;

class ContactFormMessageFactory implements ExampleFactoryInterface
{
    public function __construct(
        private readonly ContactFormMessageFactoryInterface $messageFactory,
        private readonly ContactFormSubjectRepositoryInterface $subjectRepository,
    ) {
    }

    public function create(array $options = []): ?ContactFormMessageInterface
    {
        /** @var ContactFormSubjectInterface $subject */
        $subject = $this->subjectRepository->findOneBy(['id' => $options['subject_id']]);

        /** @var ContactFormMessageInterface|null $messageContact */
        $messageContact = $this->messageFactory->createNew();

        $messageContact
            ->setSubject($subject)
            ->setName($options['name'])
            ->setEmail($options['email'])
            ->setPhone($options['phone'])
            ->setMessage($options['message'])
            ->setProcessState(ContactFormMessageInterface::STATE_TO_BE_PROCESSED)
            ->setIp('')
        ;

        return $messageContact;
    }
}
